void add1(float a[4], float b[4]) {
  for (int i = 0; i < 4; ++i) {
    a[i] += b[i];
  }
}

void add2(float a_[4], float b_[4]) {
  float* a = (float*)__builtin_assume_aligned(a_, 16);
  float* b = (float*)__builtin_assume_aligned(b_, 16);
  for (int i = 0; i < 4; ++i) {
    a[i] += b[i];
  }
}

void add3(float* __restrict a_, float* __restrict b_) {
  float* a = (float*)__builtin_assume_aligned(a_, 16);
  float* b = (float*)__builtin_assume_aligned(b_, 16);
  for (int i = 0; i < 4; ++i) {
    a[i] += b[i];
  }
}

extern void invalidate_a(float x[4]);
extern void invalidate_b(float x[4]);

void harness() {
  float a[4], b[4];
  invalidate_a(a);
  invalidate_b(b);
  add1(a, b);
  invalidate_a(a);
}
